//    File:  Singleton.java
//
//    Demonstrate how to create a Singleton object

public class Singleton {
    private Singleton() {
        // no code req'd
        // this constructor should NEVER be called...
    }

    public static synchronized Singleton getSingleton() {
        // "synchronized" makes this method thread-safe
        if (ref == null)
            // it's ok, we can call this constructor
            ref = new Singleton();
        return ref;
    }

    public Object clone() throws CloneNotSupportedException {
        // this method guarantees that no "end runs" around Singleton
        // creation can occur due to cloning
        throw new CloneNotSupportedException();
    }

    private static Singleton ref = null;

    // = = = = = = = = = = = = = = = = = = = = = = = = = =

    public static void main(String[] args) {
        System.out.println("\nDemonstrate Singleton\n");
        Singleton single1 = getSingleton();
        Singleton single2 = getSingleton();
        System.out.println("single1 == single2:  " + (single1 == single2) + "\n");
    }

}
